commit-graph: add trace2 instrumentation for generation DFS
Count the number of steps taken in compute_reachable_generation_numbers() and expose it via trace2 to make it easier to detect performance regressions. Add a failing test for such a regression, introduced in 199d452758 (commit-graph: return the prepared commit graph from `prepare_commit_graph()`, 2025-09-04), where incremental commit-graph writes do not see existing generation numbers from lower graph layers and fall back to walking the full ancestry. Signed-off-by: Kristofer Karlsson <krka@spotify.com> Signed-off-by: Junio C Hamano <gitster@pobox.com>
Kristofer Karlsson committed
Jul 9, 2026 at 15:03 UTC
02d62c33be04260445fb201fc65769f421324ed0
2 files changed
+29
commit-graph.c
+5
index c6d9c5c740..702ba9731b 100644
--- a/commit-graph.c
+++ b/commit-graph.c
@@ -1653,6 +1653,7 @@ static void compute_reachable_generation_numbers(
{
int i;
struct commit_list *list = NULL;
+ intmax_t steps = 0;
for (i = 0; i < info->commits->nr; i++) {
struct commit *c = info->commits->items[i];
@@ -1671,6 +1672,7 @@ static void compute_reachable_generation_numbers(
int all_parents_computed = 1;
timestamp_t max_gen = 0;
+ steps++;
for (parent = current->parents; parent; parent = parent->next) {
repo_parse_commit(info->r, parent->item);
gen = info->get_generation(parent->item, info->data);
@@ -1694,6 +1696,9 @@ static void compute_reachable_generation_numbers(
}
}
}
+
+ trace2_data_intmax("commit-graph", info->r,
+ "generation-dfs-steps", steps);
}
static timestamp_t get_topo_level(struct commit *c, void *data)
t/t5324-split-commit-graph.sh
+24
index 49a057cc2e..b41331e3dd 100755
--- a/t/t5324-split-commit-graph.sh
+++ b/t/t5324-split-commit-graph.sh
@@ -718,6 +718,30 @@ test_expect_success 'write generation data chunk when commit-graph chain is repl
)
'
+test_expect_failure 'incremental write reads topo levels from all layers' '
+ git init topo-from-lower &&
+ (
+ cd topo-from-lower &&
+
+ for i in $(test_seq 5)
+ do
+ test_commit base-$i || return 1
+ done &&
+ git commit-graph write --reachable &&
+
+ test_commit extra &&
+ git commit-graph write --reachable --split=no-merge &&
+
+ git checkout base-3 &&
+ test_commit new-branch &&
+
+ GIT_TRACE2_EVENT="$(pwd)/trace.txt" \
+ git commit-graph write --reachable --split=no-merge &&
+
+ test_trace2_data commit-graph generation-dfs-steps 1 <trace.txt
+ )
+'
+
test_expect_success 'temporary graph layer is discarded upon failure' '
git init layer-discard &&
(